Index: src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -59,5 +59,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisDipoleAngularCorrelationAction::performCall() {
+ActionState::ptr AnalysisDipoleAngularCorrelationAction::performCall() {
   //int ranges[3] = {1, 1, 1};
   string type;
@@ -141,9 +141,9 @@
 }
 
-Action::state_ptr AnalysisDipoleAngularCorrelationAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisDipoleAngularCorrelationAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisDipoleAngularCorrelationAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisDipoleAngularCorrelationAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }
Index: src/Actions/AnalysisAction/DipoleCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/DipoleCorrelationAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/DipoleCorrelationAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -55,5 +55,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisDipoleCorrelationAction::performCall() {
+ActionState::ptr AnalysisDipoleCorrelationAction::performCall() {
   //int ranges[3] = {1, 1, 1};
   ofstream output;
@@ -80,9 +80,9 @@
 }
 
-Action::state_ptr AnalysisDipoleCorrelationAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisDipoleCorrelationAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisDipoleCorrelationAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisDipoleCorrelationAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }
Index: src/Actions/AnalysisAction/MolecularVolumeAction.cpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -57,5 +57,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisMolecularVolumeAction::performCall() {
+ActionState::ptr AnalysisMolecularVolumeAction::performCall() {
   // execute action
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
@@ -81,9 +81,9 @@
 }
 
-Action::state_ptr AnalysisMolecularVolumeAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisMolecularVolumeAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisMolecularVolumeAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisMolecularVolumeAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }
Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -58,5 +58,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisPairCorrelationAction::performCall() {
+ActionState::ptr AnalysisPairCorrelationAction::performCall() {
   ofstream output;
   ofstream binoutput;
@@ -92,9 +92,9 @@
 }
 
-Action::state_ptr AnalysisPairCorrelationAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisPairCorrelationAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisPairCorrelationAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisPairCorrelationAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }
Index: src/Actions/AnalysisAction/PointCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -57,5 +57,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisPointCorrelationAction::performCall() {
+ActionState::ptr AnalysisPointCorrelationAction::performCall() {
   int ranges[3] = {1, 1, 1};
   ofstream output;
@@ -86,9 +86,9 @@
 }
 
-Action::state_ptr AnalysisPointCorrelationAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisPointCorrelationAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisPointCorrelationAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisPointCorrelationAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -54,5 +54,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisPrincipalAxisSystemAction::performCall() {
+ActionState::ptr AnalysisPrincipalAxisSystemAction::performCall() {
   LOG(0, "Evaluating prinicipal axis.");
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
@@ -75,9 +75,9 @@
 }
 
-Action::state_ptr AnalysisPrincipalAxisSystemAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisPrincipalAxisSystemAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisPrincipalAxisSystemAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisPrincipalAxisSystemAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 94d5ac60852caf3933c959f8314ca0be3d3a7c51)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -60,5 +60,5 @@
 
 /** =========== define the function ====================== */
-Action::state_ptr AnalysisSurfaceCorrelationAction::performCall() {
+ActionState::ptr AnalysisSurfaceCorrelationAction::performCall() {
   int ranges[3] = {1, 1, 1};
   ofstream output;
@@ -122,9 +122,9 @@
 }
 
-Action::state_ptr AnalysisSurfaceCorrelationAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr AnalysisSurfaceCorrelationAction::performUndo(ActionState::ptr _state) {
   return Action::success;
 }
 
-Action::state_ptr AnalysisSurfaceCorrelationAction::performRedo(Action::state_ptr _state){
+ActionState::ptr AnalysisSurfaceCorrelationAction::performRedo(ActionState::ptr _state){
   return Action::success;
 }