Index: tests/integration/FragmentJobs/pre/ethane.pdb
===================================================================
--- tests/integration/FragmentJobs/pre/ethane.pdb	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
+++ tests/integration/FragmentJobs/pre/ethane.pdb	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
@@ -0,0 +1,18 @@
+REMARK created by molecuilder on Fri Mar  1 19:45:11 2013, time step 0
+ATOM      1 C01 0eth 01          3.125  10.442  10.000  0.00  0.00           C 0
+ATOM      2 C02 0eth 01          4.374   9.559  10.000  0.00  0.00           C 0
+ATOM      3 H01 0eth 01          3.125  11.071   9.110  0.00  0.00           H 0
+ATOM      4 H02 0eth 01          3.125  11.071  10.890  0.00  0.00           H 0
+ATOM      5 H03 0eth 01          4.374   8.929   9.110  0.00  0.00           H 0
+ATOM      6 H04 0eth 01          4.374   8.929  10.890  0.00  0.00           H 0
+ATOM      7 H05 0eth 01          2.235   9.813  10.000  0.00  0.00           H 0
+ATOM      8 H06 0eth 01          5.264  10.188  10.000  0.00  0.00           H 0
+CONECT    1    2    3    4    7                                                 
+CONECT    2    1    5    6    8                                                 
+CONECT    3    1                                                                
+CONECT    4    1                                                                
+CONECT    5    2                                                                
+CONECT    6    2                                                                
+CONECT    7    1                                                                
+CONECT    8    2                                                                
+END
Index: tests/integration/FragmentJobs/testsuite-integration-fragmentjobs-mpqc-jobs.at
===================================================================
--- tests/integration/FragmentJobs/testsuite-integration-fragmentjobs-mpqc-jobs.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
+++ tests/integration/FragmentJobs/testsuite-integration-fragmentjobs-mpqc-jobs.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
@@ -0,0 +1,82 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### test mpqc jobs 
+
+# perform test with PoolWorkers using molecuilder_poolworker
+AT_SETUP([Integration - mpqc fragment jobs])
+AT_KEYWORDS([fragmentation automation server poolworker molecuilder_poolworker])
+
+# check that ports are unique over all tests such that they may run in parallel
+WORKERPORT=12020
+CONTROLLERPORT=12021
+WORKERLISTENPORT=12022
+
+# start service in background
+${AUTOTEST_PATH}/molecuilder_server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+server_pid=$!
+AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([kill -s 0 $server_pid], 0, [ignore], [ignore], [kill $server_pid])
+
+# enlist a worker to work on jobs
+../../molecuilder_poolworker -v 5 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+worker_script_pid=$!
+worker_pid=`ps -ef | grep molecuilder_poolworker | grep $worker_script_pid | awk '{print $2}'`
+AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([kill -s 0 $worker_pid], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+
+# create jobs via molecuilder
+molfile="ethane.pdb"
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/integration/FragmentJobs/pre/ethane.pdb $molfile], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([chmod +rw $molfile], 0)
+AT_CHECK([../../molecuilder \
+	-i $molfile \
+	--select-all-atoms \
+	--update-molecules \
+	--set-parser-parameters mpqc \
+		--parser-parameters "theory=CLHF;basis=3-21G;" \
+	--fragment-molecule BondFragment \
+		--order 2 \
+		--grid-level 5 \
+	--fragment-automation \
+		--server-address 127.0.0.1 \
+		--server-port ${CONTROLLERPORT} \
+		--DoLongrange 0 \
+	--verbose 3 \
+	--analyse-fragment-results results.dat], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+
+# send removeall to server such that all workers shutdown
+AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+
+# check that worker is truely down
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $worker_pid $server_pid])
+AT_CHECK([kill $worker_pid], 1, [ignore], [ignore], [kill $server_pid])
+
+# check number of done jobs
+AT_CHECK([fgrep "There are 3 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "There are 1 molecules to consider" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "8 atoms selected." stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([tail -n 1 BondFragment_Energy.dat | awk '{if ($2!=-78.79298686) exit 1}'], 0, [ignore], [ignore], [kill $server_pid])
+
+# shutdown controller socket 
+AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
+
+# check that server is truely down
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/integration/FragmentJobs/testsuite-integration-fragmentjobs-vmg-jobs.at
===================================================================
--- tests/integration/FragmentJobs/testsuite-integration-fragmentjobs-vmg-jobs.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
+++ tests/integration/FragmentJobs/testsuite-integration-fragmentjobs-vmg-jobs.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
@@ -0,0 +1,85 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### test vmg jobs 
+
+# perform test with PoolWorkers using molecuilder_poolworker
+AT_SETUP([Integration - mpqc and vmg fragment jobs])
+AT_KEYWORDS([fragmentation automation server poolworker molecuilder_poolworker longrange])
+
+# check that ports are unique over all tests such that they may run in parallel
+WORKERPORT=12030
+CONTROLLERPORT=12031
+WORKERLISTENPORT=12032
+
+# start service in background
+${AUTOTEST_PATH}/molecuilder_server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+server_pid=$!
+AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([kill -s 0 $server_pid], 0, [ignore], [ignore], [kill $server_pid])
+
+# enlist a worker to work on jobs
+../../molecuilder_poolworker -v 5 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+worker_script_pid=$!
+worker_pid=`ps -ef | grep molecuilder_poolworker | grep $worker_script_pid | awk '{print $2}'`
+AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([kill -s 0 $worker_pid], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+
+# create jobs via molecuilder
+molfile="ethane.pdb"
+AT_CHECK([cp -f ${abs_top_srcdir}/tests/integration/FragmentJobs/pre/ethane.pdb $molfile], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([chmod +rw $molfile], 0)
+AT_CHECK([../../molecuilder \
+	-i $molfile \
+	--bound-in-box "10,0,10,0,0,10" \
+	--set-boundary-conditions Wrap Wrap Wrap \
+	--select-all-atoms \
+	--update-molecules \
+	--set-parser-parameters mpqc \
+		--parser-parameters "theory=CLHF;basis=3-21G;" \
+	--fragment-molecule BondFragment \
+		--order 2 \
+		--grid-level 3 \
+	--fragment-automation \
+		--server-address 127.0.0.1 \
+		--server-port ${CONTROLLERPORT} \
+		--DoLongrange 1 \
+	--verbose 3 \
+	--analyse-fragment-results results.dat], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+
+# send removeall to server such that all workers shutdown
+AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+
+# check that worker is truely down
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $worker_pid $server_pid])
+AT_CHECK([kill $worker_pid], 1, [ignore], [ignore], [kill $server_pid])
+
+# check number of done jobs
+AT_CHECK([fgrep "There are 3 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "There are 1 molecules to consider" stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([fgrep "8 atoms selected." stdout], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([tail -n 2 BondFragment_LongRangeEnergy.dat | head -n 1 | awk 'function abs(v) {return v < 0.0 ? -v : v}{if (abs(($8+9.740433541)/-9.740433541) > 1e-6) exit 1}'], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([tail -n 1 BondFragment_LongRangeEnergy.dat | awk 'function abs(v) {return v < 0.0 ? -v : v}{if (abs($8+3.552713679e-15) > 1e-10) exit 1}'], 0, [ignore], [ignore], [kill $server_pid])
+
+# shutdown controller socket 
+AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
+
+# check that server is truely down
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/integration/FragmentJobs/testsuite-integration-fragmentjobs.at
===================================================================
--- tests/integration/FragmentJobs/testsuite-integration-fragmentjobs.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
+++ tests/integration/FragmentJobs/testsuite-integration-fragmentjobs.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
@@ -0,0 +1,24 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2017 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+AT_BANNER([MoleCuilder - fragment jobs integration])
+
+# check whether mpqc jobs work with controller and server and worker
+m4_include([FragmentJobs/testsuite-integration-fragmentjobs-mpqc-jobs.at])
+
+# check whether vmg jobs work with controller and server and worker
+m4_include([FragmentJobs/testsuite-integration-fragmentjobs-vmg-jobs.at])
Index: tests/integration/Makefile.am
===================================================================
--- tests/integration/Makefile.am	(revision 2945e64ab6cef848b9028092ef6c7488fd96d4a4)
+++ tests/integration/Makefile.am	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
@@ -12,6 +12,7 @@
 TESTSCRIPTS += \
 	$(srcdir)/testsuite-integration.at \
-	$(srcdir)/testsuite-integration-mpqc-jobs.at \
-	$(srcdir)/testsuite-integration-vmg-jobs.at
+	$(srcdir)/FragmentJobs/testsuite-integration-fragmentjobs.at \
+	$(srcdir)/FragmentJobs/testsuite-integration-fragmentjobs-mpqc-jobs.at \
+	$(srcdir)/FragmentJobs/testsuite-integration-fragmentjobs-vmg-jobs.at
 endif
 
Index: tests/integration/pre/ethane.pdb
===================================================================
--- tests/integration/pre/ethane.pdb	(revision 2945e64ab6cef848b9028092ef6c7488fd96d4a4)
+++ 	(revision )
@@ -1,18 +1,0 @@
-REMARK created by molecuilder on Fri Mar  1 19:45:11 2013, time step 0
-ATOM      1 C01 0eth 01          3.125  10.442  10.000  0.00  0.00           C 0
-ATOM      2 C02 0eth 01          4.374   9.559  10.000  0.00  0.00           C 0
-ATOM      3 H01 0eth 01          3.125  11.071   9.110  0.00  0.00           H 0
-ATOM      4 H02 0eth 01          3.125  11.071  10.890  0.00  0.00           H 0
-ATOM      5 H03 0eth 01          4.374   8.929   9.110  0.00  0.00           H 0
-ATOM      6 H04 0eth 01          4.374   8.929  10.890  0.00  0.00           H 0
-ATOM      7 H05 0eth 01          2.235   9.813  10.000  0.00  0.00           H 0
-ATOM      8 H06 0eth 01          5.264  10.188  10.000  0.00  0.00           H 0
-CONECT    1    2    3    4    7                                                 
-CONECT    2    1    5    6    8                                                 
-CONECT    3    1                                                                
-CONECT    4    1                                                                
-CONECT    5    2                                                                
-CONECT    6    2                                                                
-CONECT    7    1                                                                
-CONECT    8    2                                                                
-END
Index: tests/integration/testsuite-integration-mpqc-jobs.at
===================================================================
--- tests/integration/testsuite-integration-mpqc-jobs.at	(revision 2945e64ab6cef848b9028092ef6c7488fd96d4a4)
+++ 	(revision )
@@ -1,82 +1,0 @@
-#
-#    MoleCuilder - creates and alters molecular systems
-#    Copyright (C) 2017 Frederik Heber
-#
-#    This program is free software: you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation, either version 3 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License
-#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-#
-### test mpqc jobs 
-
-# perform test with PoolWorkers using molecuilder_poolworker
-AT_SETUP([Integration - fragmentation plus automated fragment calculation via mpqc])
-AT_KEYWORDS([fragmentation automation server poolworker molecuilder_poolworker])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=12020
-CONTROLLERPORT=12021
-WORKERLISTENPORT=12022
-
-# start service in background
-${AUTOTEST_PATH}/molecuilder_server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill -s 0 $server_pid], 0, [ignore], [ignore], [kill $server_pid])
-
-# enlist a worker to work on jobs
-../../molecuilder_poolworker -v 5 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
-worker_script_pid=$!
-worker_pid=`ps -ef | grep molecuilder_poolworker | grep $worker_script_pid | awk '{print $2}'`
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([kill -s 0 $worker_pid], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# create jobs via molecuilder
-molfile="ethane.pdb"
-AT_CHECK([cp -f ${abs_top_srcdir}/tests/integration/pre/ethane.pdb $molfile], 0)
-AT_CHECK([chmod +rw $molfile], 0)
-AT_CHECK([../../molecuilder \
-	-i $molfile \
-	--select-all-atoms \
-	--update-molecules \
-	--set-parser-parameters mpqc \
-		--parser-parameters "theory=CLHF;basis=3-21G;" \
-	--fragment-molecule BondFragment \
-		--order 2 \
-		--grid-level 5 \
-	--fragment-automation \
-		--server-address 127.0.0.1 \
-		--server-port ${CONTROLLERPORT} \
-		--DoLongrange 0 \
-	--verbose 3 \
-	--analyse-fragment-results results.dat], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# send removeall to server such that all workers shutdown
-AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# check that worker is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $worker_pid $server_pid])
-AT_CHECK([kill $worker_pid], 1, [ignore], [ignore], [kill $server_pid])
-
-# check number of done jobs
-AT_CHECK([fgrep "There are 3 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "There are 1 molecules to consider" stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "8 atoms selected." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([tail -n 1 BondFragment_Energy.dat | awk '{if ($2!=-78.79298686) exit 1}'], 0, [ignore], [ignore], [kill $server_pid])
-
-# shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/integration/testsuite-integration-vmg-jobs.at
===================================================================
--- tests/integration/testsuite-integration-vmg-jobs.at	(revision 2945e64ab6cef848b9028092ef6c7488fd96d4a4)
+++ 	(revision )
@@ -1,85 +1,0 @@
-#
-#    MoleCuilder - creates and alters molecular systems
-#    Copyright (C) 2017 Frederik Heber
-#
-#    This program is free software: you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation, either version 3 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License
-#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-#
-### test vmg jobs 
-
-# perform test with PoolWorkers using molecuilder_poolworker
-AT_SETUP([Integration - fragmentation plus automated fragment calculation with longrange])
-AT_KEYWORDS([fragmentation automation server poolworker molecuilder_poolworker longrange])
-
-# check that ports are unique over all tests such that they may run in parallel
-WORKERPORT=12030
-CONTROLLERPORT=12031
-WORKERLISTENPORT=12032
-
-# start service in background
-${AUTOTEST_PATH}/molecuilder_server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
-server_pid=$!
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill -s 0 $server_pid], 0, [ignore], [ignore], [kill $server_pid])
-
-# enlist a worker to work on jobs
-../../molecuilder_poolworker -v 5 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
-worker_script_pid=$!
-worker_pid=`ps -ef | grep molecuilder_poolworker | grep $worker_script_pid | awk '{print $2}'`
-AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-AT_CHECK([kill -s 0 $worker_pid], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# create jobs via molecuilder
-molfile="ethane.pdb"
-AT_CHECK([cp -f ${abs_top_srcdir}/tests/integration/pre/ethane.pdb $molfile], 0)
-AT_CHECK([chmod +rw $molfile], 0)
-AT_CHECK([../../molecuilder \
-	-i $molfile \
-	--bound-in-box "10,0,10,0,0,10" \
-	--set-boundary-conditions Wrap Wrap Wrap \
-	--select-all-atoms \
-	--update-molecules \
-	--set-parser-parameters mpqc \
-		--parser-parameters "theory=CLHF;basis=3-21G;" \
-	--fragment-molecule BondFragment \
-		--order 2 \
-		--grid-level 3 \
-	--fragment-automation \
-		--server-address 127.0.0.1 \
-		--server-port ${CONTROLLERPORT} \
-		--DoLongrange 1 \
-	--verbose 3 \
-	--analyse-fragment-results results.dat], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
-
-# send removeall to server such that all workers shutdown
-AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
-
-# check that worker is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $worker_pid $server_pid])
-AT_CHECK([kill $worker_pid], 1, [ignore], [ignore], [kill $server_pid])
-
-# check number of done jobs
-AT_CHECK([fgrep "There are 3 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "There are 1 molecules to consider" stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([fgrep "8 atoms selected." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([tail -n 2 BondFragment_LongRangeEnergy.dat | head -n 1 | awk 'function abs(v) {return v < 0.0 ? -v : v}{if (abs(($8+9.740433541)/-9.740433541) > 1e-6) exit 1}'], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([tail -n 1 BondFragment_LongRangeEnergy.dat | awk 'function abs(v) {return v < 0.0 ? -v : v}{if (abs($8+3.552713679e-15) > 1e-10) exit 1}'], 0, [ignore], [ignore], [kill $server_pid])
-
-# shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/molecuilder_controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
-
-# check that server is truely down
-AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([kill $server_pid], 1, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/integration/testsuite-integration.at
===================================================================
--- tests/integration/testsuite-integration.at	(revision 2945e64ab6cef848b9028092ef6c7488fd96d4a4)
+++ tests/integration/testsuite-integration.at	(revision 6491d3fd495cb3539c6999bc57f5fe2d2bee92c9)
@@ -18,7 +18,4 @@
 AT_BANNER([MoleCuilder - integration test])
 
-# check whether mpqc jobs work with controller and server and worker
-m4_include([testsuite-integration-mpqc-jobs.at])
-
-# check whether vmg jobs work with controller and server and worker
-m4_include([testsuite-integration-vmg-jobs.at])
+# check integration of fragment jobs energy calculation
+m4_include([FragmentJobs/testsuite-integration-fragmentjobs.at])