Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 7ea9e616afe1db1bdce286f712abff18030a7ce5)
+++ src/unittests/Makefile.am	(revision 7326b21cef2429a9070eeb36352bb77cf6b12c2c)
@@ -4,5 +4,5 @@
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
 
-TESTS = ActOnAllUnitTest AnalysisCorrelationToPointUnitTest AnalysisCorrelationToSurfaceUnitTest AnalysisPairCorrelationUnitTest BondGraphUnitTest ListOfBondsUnitTest MemoryUsageObserverUnitTest MemoryAllocatorUnitTest StackClassUnitTest VectorUnitTest
+TESTS = ActOnAllUnitTest AnalysisCorrelationToPointUnitTest AnalysisCorrelationToSurfaceUnitTest AnalysisPairCorrelationUnitTest BondGraphUnitTest ListOfBondsUnitTest LogUnitTest MemoryUsageObserverUnitTest MemoryAllocatorUnitTest StackClassUnitTest VectorUnitTest
 check_PROGRAMS = $(TESTS)
 noinst_PROGRAMS = $(TESTS)
@@ -25,5 +25,8 @@
 ListOfBondsUnitTest_LDADD = ../libmolecuilder.a
 
-MemoryAllocatorUnitTest_SOURCES = defs.hpp ../helpers.cpp ../helpers.hpp memoryallocatorunittest.cpp memoryallocatorunittest.hpp memoryallocator.hpp memoryusageobserver.hpp verbose.hpp 
+LogUnitTest_SOURCES = logunittest.cpp logunittest.hpp 
+LogUnitTest_LDADD = ../libmolecuilder.a
+
+MemoryAllocatorUnitTest_SOURCES = defs.hpp ../helpers.cpp ../helpers.hpp memoryallocatorunittest.cpp memoryallocatorunittest.hpp memoryallocator.hpp ../memoryusageobserver.cpp memoryusageobserver.hpp ../verbose.cpp verbose.hpp 
 
 MemoryUsageObserverUnitTest_SOURCES = defs.hpp helpers.hpp memoryusageobserverunittest.cpp memoryusageobserverunittest.hpp memoryusageobserver.hpp verbose.hpp 
@@ -31,6 +34,7 @@
 StackClassUnitTest_SOURCES = memoryallocator.hpp stackclass.hpp stackclassunittest.cpp stackclassunittest.hpp
 
-VectorUnitTest_SOURCES = defs.hpp ../helpers.cpp helpers.hpp ../leastsquaremin.cpp leastsquaremin.hpp memoryallocator.hpp memoryusageobserver.hpp vectorunittest.cpp vectorunittest.hpp vector.hpp ../vector.cpp verbose.hpp ../verbose.cpp 
+VectorUnitTest_SOURCES = defs.hpp ../helpers.cpp helpers.hpp ../leastsquaremin.cpp leastsquaremin.hpp memoryallocator.hpp memoryusageobserver.hpp ../memoryusageobserver.cpp vectorunittest.cpp vectorunittest.hpp vector.hpp ../vector.cpp verbose.hpp ../verbose.cpp 
 
 
 #AUTOMAKE_OPTIONS = parallel-tests
+
Index: src/unittests/logunittest.cpp
===================================================================
--- src/unittests/logunittest.cpp	(revision 7326b21cef2429a9070eeb36352bb77cf6b12c2c)
+++ src/unittests/logunittest.cpp	(revision 7326b21cef2429a9070eeb36352bb77cf6b12c2c)
@@ -0,0 +1,73 @@
+/*
+ * logunittest.cpp
+ */
+
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "logunittest.hpp"
+#include "logger.hpp"
+#include "errorLogger.hpp"
+#include "log.hpp"
+#include "defs.hpp"
+#include "verbose.hpp"
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( LogTest );
+
+
+void LogTest::setUp()
+{
+};
+
+void LogTest::tearDown()
+{
+};
+
+/**
+ * UnitTest for log()
+ */
+void LogTest::logTest()
+{
+  logger::getInstance()->setVerbosity(2);
+  cout << "Verbosity level is set to 2." << endl;
+  log() << Verbose(0) << "Test level 0" << endl;
+  log() << Verbose(1) << "Test level 1" << endl;
+  log() << Verbose(2) << "Test level 2" << endl;
+  log() << Verbose(3) << "Test level 3" << endl;
+  log() << Verbose(4) << "Test level 4" << endl;
+
+  log() << Verbose(0) << "Output a log message." << endl;
+  elog() << Verbose(0) << "Output an error message." << endl;
+  setVerbosity(3);
+  log() << Verbose(4) << "This should not be printed." << endl;
+  elog() << Verbose(4) << "This should not be printed." << endl;
+};
+
+
+/********************************************** Main routine **************************************/
+
+int main(int argc, char **argv)
+{
+  // Get the top level suite from the registry
+  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();
+
+  // Adds the test to the list of test to run
+  CppUnit::TextUi::TestRunner runner;
+  runner.addTest( suite );
+
+  // Change the default outputter to a compiler error format outputter
+  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
+                                                       std::cerr ) );
+  // Run the tests.
+  bool wasSucessful = runner.run();
+
+  // Return error code 1 if the one of test failed.
+  return wasSucessful ? 0 : 1;
+};
Index: src/unittests/logunittest.hpp
===================================================================
--- src/unittests/logunittest.hpp	(revision 7326b21cef2429a9070eeb36352bb77cf6b12c2c)
+++ src/unittests/logunittest.hpp	(revision 7326b21cef2429a9070eeb36352bb77cf6b12c2c)
@@ -0,0 +1,26 @@
+/*
+ * logunittest.hpp
+ */
+
+#ifndef LOGTEST_HPP_
+#define LOGTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+
+/********************************************** Test classes **************************************/
+
+class LogTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( LogTest) ;
+    CPPUNIT_TEST ( logTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+    void setUp();
+    void tearDown();
+
+    void logTest();
+};
+
+#endif /* LOGTEST_HPP_ */