Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 511645e9b697691c5ed31f3c31d97987d4216953)
+++ src/UIElements/Makefile.am	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
@@ -205,4 +205,5 @@
   UIElements/Views/Qt4/QtElementList.cpp \
   UIElements/Views/Qt4/QtStatusBar.cpp \
+  UIElements/Views/Qt4/QtToolBar.cpp \
   UIElements/Views/Qt4/Qt3D/GLWorldView.cpp \
   UIElements/Views/Qt4/Qt3D/GLWorldScene.cpp \
@@ -238,4 +239,5 @@
   UIElements/Views/Qt4/QtElementList.hpp \
   UIElements/Views/Qt4/QtStatusBar.hpp \
+  UIElements/Views/Qt4/QtToolBar.hpp \
   UIElements/Views/Qt4/Qt3D/GLWorldView.hpp \
  	UIElements/Views/Qt4/Qt3D/GLWorldScene.hpp \
Index: src/UIElements/Qt4/QtMainWindow.cpp
===================================================================
--- src/UIElements/Qt4/QtMainWindow.cpp	(revision 511645e9b697691c5ed31f3c31d97987d4216953)
+++ src/UIElements/Qt4/QtMainWindow.cpp	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
@@ -25,4 +25,5 @@
 #include<Qt/qmenubar.h>
 #include<Qt/qsplitter.h>
+#include<Qt/qtoolbar.h>
 
 #include<iostream>
@@ -36,4 +37,5 @@
 #include "Views/Qt4/QtMoleculeView.hpp"
 #include "Views/Qt4/QtStatusBar.hpp"
+#include "Views/Qt4/QtToolBar.hpp"
 #include "Views/Qt4/Qt3D/GLWorldView.hpp"
 
@@ -67,4 +69,7 @@
   MainMenu->init();
 
+  toolbar = new QtToolBar(this);
+  addToolBar(toolbar);
+
   setCentralWidget(splitter1);
   splitter1->addWidget(splitter2);
Index: src/UIElements/Qt4/QtMainWindow.hpp
===================================================================
--- src/UIElements/Qt4/QtMainWindow.hpp	(revision 511645e9b697691c5ed31f3c31d97987d4216953)
+++ src/UIElements/Qt4/QtMainWindow.hpp	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
@@ -29,4 +29,5 @@
 class QtMoleculeView;
 class QtStatusBar;
+class QtToolBar;
 
 class QtMainWindow : public QMainWindow, public MainWindow
@@ -50,4 +51,5 @@
   QtStatusBar *statusBar;
   QtMenu<QMenuBar> *MainMenu;
+  QtToolBar *toolbar;
 
 };
Index: src/UIElements/Views/Qt4/QtToolBar.cpp
===================================================================
--- src/UIElements/Views/Qt4/QtToolBar.cpp	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
+++ src/UIElements/Views/Qt4/QtToolBar.cpp	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
@@ -0,0 +1,48 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtToolBar.cpp
+ *
+ *  Created on: Apr 26, 2012
+ *      Author: ankele
+ */
+
+
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "QtToolBar.hpp"
+
+#include "CodePatterns/MemDebug.hpp"
+
+QtToolBar::QtToolBar(QWidget * _parent) :
+  QToolBar(_parent)
+{
+  addActionItem("undo", "undo", "edit-undo");
+  addActionItem("redo", "redo", "edit-redo");
+}
+
+
+QtToolBar::~QtToolBar()
+{
+}
+
+
+void QtToolBar::addActionItem(const std::string &token, const std::string &description, const std::string &icon_name)
+{
+  QAction *action = addAction(QString(description.c_str()));
+  action->setIcon(QIcon::fromTheme(QString(icon_name.c_str())));
+  QtMenuPipe *pipe = new QtMenuPipe(token,action);
+  QObject::connect(action, SIGNAL(triggered()),pipe,SLOT(called()));
+  plumbing.push_back(pipe);
+}
Index: src/UIElements/Views/Qt4/QtToolBar.hpp
===================================================================
--- src/UIElements/Views/Qt4/QtToolBar.hpp	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
+++ src/UIElements/Views/Qt4/QtToolBar.hpp	(revision 7641d4e1b3ea4b5b8ead0b28ccfc5977f0589e4e)
@@ -0,0 +1,38 @@
+/*
+ * QtToolBar.hpp
+ *
+ *  Created on: Apr 26, 2012
+ *      Author: ankele
+ */
+
+#ifndef QTTOOLBAR_HPP_
+#define QTTOOLBAR_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <Qt/qaction.h>
+#include <QtGui/QToolBar>
+
+#include "Menu/Qt4/QtMenuPipe.hpp"
+
+
+class QtToolBar : public QToolBar
+{
+  Q_OBJECT
+public:
+  QtToolBar(QWidget * _parent=0);
+  virtual ~QtToolBar();
+
+private:
+  std::list<QtMenuPipe*> plumbing;
+
+  void addActionItem(const std::string &token, const std::string &description, const std::string &icon_name);
+
+};
+
+
+#endif /* QTTOOLBAR_HPP_ */