Index: tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at	(revision 23110a4092c457be30e89f88181ea2df46c504e5)
+++ tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at	(revision 7774f7e70f2ae517967d41e9125f5dba0adf1dbe)
@@ -21,5 +21,5 @@
 AT_KEYWORDS([options mpqc set-mpqc-parameters basis])
 
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G"], 0, [stdout], [ignore])
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis=4-31G"], 0, [stdout], [ignore])
 AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
 
@@ -30,5 +30,5 @@
 AT_KEYWORDS([options mpqc set-mpqc-parameters basis undo])
 
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G" --undo], 0, [stdout], [ignore])
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis=4-31G" --undo], 0, [stdout], [ignore])
 AT_CHECK([fgrep "name = \"3-21G\"" test.in], 0, [ignore], [ignore])
 
@@ -39,5 +39,5 @@
 AT_KEYWORDS([options mpqc set-mpqc-parameters basis redo])
 
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis=4-31G" --undo --redo], 0, [stdout], [ignore])
 AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
 
Index: tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at	(revision 23110a4092c457be30e89f88181ea2df46c504e5)
+++ tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at	(revision 7774f7e70f2ae517967d41e9125f5dba0adf1dbe)
@@ -21,5 +21,5 @@
 AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter])
 
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter = 499"], 0, [stdout], [ignore])
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter=499"], 0, [stdout], [ignore])
 AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
 
@@ -30,5 +30,5 @@
 AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter undo])
 
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter = 499" --undo], 0, [stdout], [ignore])
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter=499" --undo], 0, [stdout], [ignore])
 AT_CHECK([fgrep "maxiter = 1000" test.in], 0, [ignore], [ignore])
 
@@ -39,5 +39,5 @@
 AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter redo])
 
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter = 499" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter=499" --undo --redo], 0, [stdout], [ignore])
 AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
 